<html>
<head>
<title>OGRE: OgreUnifiedHighLevelGpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreUnifiedHighLevelGpuProgram.h</h1><a href="OgreUnifiedHighLevelGpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __UnifiedHighLevelGpuProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __UnifiedHighLevelGpuProgram_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreHighLevelGpuProgram_8h.html">OgreHighLevelGpuProgram.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreHighLevelGpuProgramManager_8h.html">OgreHighLevelGpuProgramManager.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00055"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html">00055</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html" title="Specialisation of HighLevelGpuProgram which just delegates its implementation to...">UnifiedHighLevelGpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program)...">HighLevelGpuProgram</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram_1_1CmdDelegate.html">00059</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram_1_1CmdDelegate.html" title="Command object for setting delegate (can set more than once).">CmdDelegate</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00060"></a>00060         {
<a name="l00061"></a>00061         <span class="keyword">public</span>:
<a name="l00062"></a>00062             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> doGet(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00063"></a>00063             <span class="keywordtype">void</span> doSet(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00064"></a>00064         };
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keyword">protected</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#7a8a017bf089486c19feed2bf671a36f">00067</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram_1_1CmdDelegate.html" title="Command object for setting delegate (can set more than once).">CmdDelegate</a> msCmdDelegate;
<a name="l00068"></a>00068 
<a name="l00070"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#363bfe4317112b7b810115f9c2abf7d1">00070</a>         <a class="code" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> mDelegateNames;
<a name="l00072"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html#7c113a6bbe545bb30b619805dca5a82f">00072</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr...">HighLevelGpuProgramPtr</a> mChosenDelegate;
<a name="l00073"></a>00073 
<a name="l00075"></a>00075         <span class="keywordtype">void</span> chooseDelegate() <span class="keyword">const</span>;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077         <span class="keywordtype">void</span> createLowLevelImpl(<span class="keywordtype">void</span>);
<a name="l00078"></a>00078         <span class="keywordtype">void</span> unloadHighLevelImpl(<span class="keywordtype">void</span>);
<a name="l00079"></a>00079         <span class="keywordtype">void</span> buildConstantDefinitions() <span class="keyword">const</span>;
<a name="l00080"></a>00080         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     <span class="keyword">public</span>:
<a name="l00084"></a>00084         <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html" title="Specialisation of HighLevelGpuProgram which just delegates its implementation to...">UnifiedHighLevelGpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle,
<a name="l00085"></a>00085             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00086"></a>00086         ~<a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgram.html" title="Specialisation of HighLevelGpuProgram which just delegates its implementation to...">UnifiedHighLevelGpuProgram</a>();
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00093"></a>00093         <span class="keywordtype">void</span> addDelegateProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00094"></a>00094 
<a name="l00096"></a>00096         <span class="keywordtype">void</span> clearDelegatePrograms();
<a name="l00097"></a>00097 
<a name="l00099"></a>00099         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr...">HighLevelGpuProgramPtr</a>&amp; _getDelegate() <span class="keyword">const</span>;
<a name="l00100"></a>00100 
<a name="l00102"></a>00102         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getLanguage(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00103"></a>00103 
<a name="l00111"></a>00111         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00113"></a>00113         <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* _getBindingDelegate(<span class="keywordtype">void</span>);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115         <span class="comment">// All the following methods must delegate to the implementation</span>
<a name="l00116"></a>00116 
<a name="l00118"></a>00118         <span class="keywordtype">bool</span> isSupported(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00119"></a>00119         
<a name="l00121"></a>00121         <span class="keywordtype">bool</span> isSkeletalAnimationIncluded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123         <span class="keywordtype">bool</span> isMorphAnimationIncluded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125         <span class="keywordtype">bool</span> isPoseAnimationIncluded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127         <span class="keywordtype">bool</span> isVertexTextureFetchRequired(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00128"></a>00128         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> getDefaultParameters(<span class="keywordtype">void</span>);
<a name="l00129"></a>00129         <span class="keywordtype">bool</span> hasDefaultParameters(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00130"></a>00130         <span class="keywordtype">bool</span> getPassSurfaceAndLightStates(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00131"></a>00131         <span class="keywordtype">bool</span> hasCompileError(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00132"></a>00132         <span class="keywordtype">void</span> resetCompileError(<span class="keywordtype">void</span>);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134         <span class="keywordtype">void</span> load(<span class="keywordtype">bool</span> backgroundThread = <span class="keyword">false</span>);
<a name="l00135"></a>00135         <span class="keywordtype">void</span> reload(<span class="keywordtype">void</span>);
<a name="l00136"></a>00136         <span class="keywordtype">bool</span> isReloadable(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00137"></a>00137         <span class="keywordtype">bool</span> isLoaded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00138"></a>00138         <a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a> isLoading() <span class="keyword">const</span>;
<a name="l00139"></a>00139         <a class="code" href="classOgre_1_1Resource.html#07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a> getLoadingState() <span class="keyword">const</span>;
<a name="l00140"></a>00140         <span class="keywordtype">void</span> unload(<span class="keywordtype">void</span>);
<a name="l00141"></a>00141         <span class="keywordtype">size_t</span> getSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00142"></a>00142         <span class="keywordtype">void</span> touch(<span class="keywordtype">void</span>);
<a name="l00143"></a>00143         <span class="keywordtype">bool</span> isBackgroundLoaded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00144"></a>00144         <span class="keywordtype">void</span> setBackgroundLoaded(<span class="keywordtype">bool</span> bl);
<a name="l00145"></a>00145         <span class="keywordtype">void</span> escalateLoading();
<a name="l00146"></a>00146         <span class="keywordtype">void</span> addListener(Listener* lis);
<a name="l00147"></a>00147         <span class="keywordtype">void</span> removeListener(Listener* lis);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     };
<a name="l00150"></a>00150 
<a name="l00152"></a><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html">00152</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html" title="Factory class for Unified programs.">UnifiedHighLevelGpuProgramFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramFactory.html" title="Interface definition for factories of HighLevelGpuProgram.">HighLevelGpuProgramFactory</a>
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154     <span class="keyword">public</span>:
<a name="l00155"></a>00155         <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#cca4706f7fc63cb7db6892f4571af5dc">UnifiedHighLevelGpuProgramFactory</a>();
<a name="l00156"></a>00156         <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#4bcd1224c7aebfd90b777337ef3b6a43">~UnifiedHighLevelGpuProgramFactory</a>();
<a name="l00158"></a>00158         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#3e96efa421a2c76c101a9ed4fcc64c25" title="Get the name of the language this factory creates programs for.">getLanguage</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00159"></a>00159         <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program)...">HighLevelGpuProgram</a>* <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#1660f65a2992bb11ab8ca778d9db35a5">create</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, 
<a name="l00160"></a>00160             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle,
<a name="l00161"></a>00161             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00162"></a>00162         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1UnifiedHighLevelGpuProgramFactory.html#f82a2c2bac74d8bcc903db82160c5d7e">destroy</a>(<a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program)...">HighLevelGpuProgram</a>* prog);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     };
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
